;Przykładowy program POOL, możesz go używać,
;modyfikować i rozpowszechniać na licencji GPL.
;Autorzy: R&D Independent Team
;Źródło: www.pool-rnd.com

include "elastic.l

to arrow :p :c :d
  ht
  "f := 0
  to force :x :y
    op array (0.01 * :f * :d,1) (0.01 * :f * :d,2)
  end

  let "l label "oOo :p
  let "pressed false
  let "start "false
  to start
    settext :l 0 "start := true
  end
  to onkeydown :code
    if :start && :code = :c ["pressed := true]
  end
  to onkeyup :code
    if :start && :code = :c ["pressed := false]
  end

  let "k 0
  let "fprev :f
  to onsignalarrows
    ifelse :pressed [
      if :f < 100 ["f += 1.5]
      if :f > 100 ["f := 100]
    ] [
      if :f > 0 ["f *= 0.9]
      if :f < 0 ["f := 0]
    ]
    if (:k % 3 = 0) && (:f <> :fprev) [
      settext :l int :f
      "fprev := :f
    ]
    "k += 1
  end
end

to hole :q :r
  local [d w g]
  to force :x :y
    "x := xcor - :x
    "y := ycor - :y
    "d := sqrt :x^2 + :y^2
    "w := (:d / :r)^2
    "g := (0.5 - (1.5 / exp :w^3)) / (-0.5 * (:w + 1) * :d)
    op array (:g * :x) (:g * :y)
  end

  to fdraw :x :y
    let "d2 (:x - xcor)^2 + (:y - ycor)^2
    let "c 100 * :d2 / :r^2
    if :c > 100 ["c := (100 - 85 * ((sqrt :d2) - :r))]
    if :c < 0 ["c := 0]
    op (array 100 100 100 :c)
  end

  to draw :a (render $fdraw :a :p0 :p1) end

  ht pu setxy (rnorm :q,1 50) (rnorm :q,2 50)
  let "p0 array (xcor - :r - 4) (ycor + :r + 4)
  let "p1 array (xcor + :r + 4) (ycor - :r - 4)
  draw 60
end

to field :amp
  to finit :x :y
    let "c newarray 4
    :c,:i := 50 * (1 + sin :a + :m,1 * :x + :m,2 * :y)
    :c,:j := 50 * (1 + cos :b + :m,3 * :x + :m,4 * :y)
    :c,:k := 50 * (1 + cos :a + :m,5 * sqrt :x^2 + :y^2)
    :c,:l := 50 * (1 + (cos :m,2 * :x) * (cos :m,1 * :y))
    op :c
  end

  to force :x :y
    let "c finit :x :y
    ;let "c pointxy :x :y
    let "g 0.0001 * :amp * :c,4
    op array (:g * (:c,1 - 50)) (:g * (:c,2 - 50))
  end

  let "i 1 + random 4
  let "j 1 + :i % 4
  let "k 1 + (:i + 1) % 4
  let "l 1 + (:i + 2) % 4
  let "a runif 360
  let "b runif 360
  let "m newarray 5
  for [q 1 5] [:m,:q := (runif 0.2 1)]
  (render $finit 75)
  signal "ok
end

to ball :mass [:loss 0.015]
  use elastic_m1 array rnorm 150 rnorm 150

  to sum_forces
    let "fa (force xcor ycor) @ :fs
    let "f newarray 2
    foreach "d :fa [
      :f,1 += :d,1
      :f,2 += :d,2
    ]
    output :f
  end

  to onsignalstep :turtle :data
    let "dt :data,2
    ifelse :dt < 80 ["dt := 0.01 * :dt] ["dt := 0.8]
    let "f sum_forces
    lock "speed [
      let "mdir movedir
      :mdir,1 := :mdir,1 * :speed + :f,1 * :dt / :mass
      :mdir,2 := :mdir,2 * :speed + :f,2 * :dt / :mass
      "speed := sqrt (:mdir,1)^2 + (:mdir,2)^2
      if :speed > 30 ["speed := 30]
      setmovedir :mdir alignh
      let "ds :speed * :dt
      "speed -= :loss * :ds
      if :speed < 0 ["speed := 0]
    ]
    fd :ds
  end

  setti "yellow_ball
  (setpc "purple 40)
  setr 8
  st
end

ht
bounce
setbg "black
shared "fs
"fs := newarray 8
:fs,1 := (anewt $hole {0 60} (runif 25 75))
:fs,2 := (anewt $hole {-100 -50} (runif 25 75))
:fs,3 := (anewt $hole {100 -40} (runif 25 75))
:fs,4 := (anewt $field 0.25)
:fs,5 := (anewt $arrow [20 40 60 22] 37 {-1 0}) ;left
:fs,6 := (anewt $arrow [90 40 60 22] 39 {1 0})  ;right
:fs,7 := (anewt $arrow [55 12 60 22] 38 {0 1})  ;up
:fs,8 := (anewt $arrow [55 68 60 22] 40 {0 -1}) ;down

"k1 := (anewturtles 3 $ball 1)

waitsignal "ok
for [i 5 [count :fs]] [start @ :fs,:i]
for [di 1 3] [(draw 10) @ :fs,:di]

"u := timer "arrows 15
"t := timer "step 11


